unit About_Box;

interface

{$mode delphi}{$H+}
uses 
  LResources, SysUtils, Classes, Dialogs, Forms, StdCtrls, Controls, Buttons, Graphics, ExtCtrls
{$ifdef Linux}
  , unix;
{$else}
  , ShellApi;
{$endif}

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    Shadow: TLabel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    OS: TLabel;
    OS_shadow: TLabel;
    OKButton: TButton;
    URL: TSpeedButton;
    MailAdress: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure URLClick(Sender: TObject);
    procedure MailAdressClick(Sender: TObject);
  private
  public
  end;

var
  AboutBox: TAboutBox;

implementation



procedure TAboutBox.FormShow(Sender: TObject);
begin
  Shadow.Caption := ProductName.Caption;
  OS.Left := ProductName.Left + ProductName.Width + 5;
  OS_shadow.Left := OS.Left + 2;
  {$ifdef MSWINDOWS}
  OS.Caption:= 'for Windows';
  OS_shadow.Caption := OS.Caption;
  {$endif}
end;

procedure TAboutBox.OKButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TAboutBox.URLClick(Sender: TObject);
begin
  {$ifdef Linux}
     if Shell('kfmclient openURL "' + URL.Caption + '"') = -1 then
      if Shell('mozilla ' + URL.Caption) = -1 then
        if Shell('netscape ' + URL.Caption) = -1 then
          ShowMessage('Sorry, cannot open a browser.');
  {$else}
  ShellExecute(Handle, 'Open', PChar(URL.Caption), nil, '', 0);
  {$endif}
end;

procedure TAboutBox.MailAdressClick(Sender: TObject);
begin
  {$ifdef Linux}
  {$else}
  ShellExecute(Handle, 'Open', PChar('mailto:' + MailAdress.Caption + '?subject=' + Trim(ProductName.Caption)), nil, '', 0);
  {$endif}
end;

Initialization
{$I About_Box.lrs}
end.
