unit Condition_Dialog;

interface

{$mode delphi}{$H+}
uses 
  LResources, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls, ComCtrls
{$ifdef Linux}
  , unix;
{$else}
  ;
{$endif}

type

  { TConditionDialog }

  TConditionDialog = class(TForm)
    edBRb1: TEdit;
    edBRb2: TEdit;
    edGRb1: TEdit;
    edGRb2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    seRedMin: TSpinEdit;
    seRedMax: TSpinEdit;
    Label1: TLabel;
    Label4: TLabel;
    chkBlueToRedMin: TCheckBox;
    edBRa1: TEdit;
    chkBlueToRedMax: TCheckBox;
    edBRa2: TEdit;
    chkGreenToRedMin: TCheckBox;
    edGRa2: TEdit;
    chkGreenToRedMax: TCheckBox;
    edGRa1: TEdit;
    btnOK: TButton;
    btnHelp: TButton;
    btnCancel: TButton;
    chkChangeColor: TCheckBox;
    ColorPanel: TPanel;
    ColorDialog: TColorDialog;
    chkBrightness: TCheckBox;
    TrackBar: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure chkBlueToRedMinClick(Sender: TObject);
    procedure chkBlueToRedMaxClick(Sender: TObject);
    procedure chkGreenToRedMinClick(Sender: TObject);
    procedure chkGreenToRedMaxClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure ColorPanelDblClick(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
    procedure chkBrightnessClick(Sender: TObject);
  private
    { Private  }
  public
    { Public  }
  end;

var
  ConditionDialog: TConditionDialog;

implementation

uses
  Digitizer_Main;

procedure TConditionDialog.FormShow(Sender: TObject);
begin
  seRedMin.Value   := RedMin;
  seRedMax.Value   := RedMax;
  if (BRa1 > 0) or (BRb1 > 0) then
    chkBlueToRedMin.Checked := True
  else
    chkBlueToRedMin.Checked := False;
  if (BRa2 < 1000) and (BRb2 < 256) then
    chkBlueToRedMax.Checked := True
  else
    chkBlueToRedMax.Checked := False;
  if (GRa1 > 0) or (GRb1 > 0) then
    chkGreenToRedMin.Checked := True
  else
    chkGreenToRedMin.Checked := False;
  if (GRa2 < 1000) and (GRb2 < 256) then
    chkGreenToRedMax.Checked := True
  else
    chkGreenToRedMax.Checked := False;
  chkBlueToRedMinClick(Sender);
  chkBlueToRedMaxClick(Sender);
  chkGreenToRedMinClick(Sender);
  chkGreenToRedMaxClick(Sender);
  chkChangeColor.Checked := ChangeColor;
  ColorPanel.Color := AlterColor;
  chkBrightness.Checked := BasedOnBrightness;
  ConditionDialog.TrackBar.Position := Trunc(BrightnessLimit * 10);
end;

procedure TConditionDialog.FormCreate(Sender: TObject);
begin

end;

procedure TConditionDialog.chkBlueToRedMinClick(Sender: TObject);
begin
  edBRa1.Enabled := chkBlueToRedMin.Checked;
  edBRb1.Enabled := chkBlueToRedMin.Checked;
  if chkBlueToRedMin.Checked = True then
  begin
    edBRa1.Text := FloatToStr(BRa1);
    edBRb1.Text := FloatToStr(BRb1);
  end
  else
  begin
    edBRa1.Text := '';
    edBRb1.Text := '';
  end;
end;

procedure TConditionDialog.chkBlueToRedMaxClick(Sender: TObject);
begin
  edBRa2.Enabled := chkBlueToRedMax.Checked;
  edBRb2.Enabled := chkBlueToRedMax.Checked;
  if chkBlueToRedMax.Checked = True then
  begin
    edBRa2.Text := FloatToStr(BRa2);
    edBRb2.Text := FloatToStr(BRb2);
  end
  else
  begin
    edBRa2.Text := '';
    edBRb2.Text := '';
  end;
end;

procedure TConditionDialog.chkGreenToRedMinClick(Sender: TObject);
begin
  edGRa1.Enabled := chkGreenToRedMin.Checked;
  edGRb1.Enabled := chkGreenToRedMin.Checked;
  if chkGreenToRedMin.Checked = True then
  begin
    edGRa1.Text := FloatToStr(GRa1);
    edGRb1.Text := FloatToStr(GRb1);
  end
  else
  begin
    edGRa2.Text := '';
    edGRb1.Text := '';
  end;
end;

procedure TConditionDialog.chkGreenToRedMaxClick(Sender: TObject);
begin
  edGRa2.Enabled := chkGreenToRedMax.Checked;
  edGRb2.Enabled := chkGreenToRedMax.Checked;
  if chkGreenToRedMax.Checked = True then
  begin
    edGRa2.Text := FloatToStr(GRa2);
    edGRb2.Text := FloatToStr(GRb2);
  end
  else
  begin
    edGRa2.Text := '';
    edGRb2.Text := '';
  end;
end;

procedure TConditionDialog.btnOKClick(Sender: TObject);
begin
  RedMin := seRedMin.Value;
  RedMax := seRedMax.Value;
  if chkBlueToRedMin.Checked = True then
  begin
    BRa1 := StrToFloat(edBRa1.Text);
    BRb1 := StrToFloat(edBRb1.Text);
  end
  else
  begin
    BRa1 := 0;
    BRb1 := 0;
  end;
  if chkBlueToRedMax.Checked = True then
  begin
    BRa2 := StrToFloat(edBRa2.Text);
    BRb2 := StrToFloat(edBRb2.Text);
  end
  else
  begin
    BRa2 := 1000;
    BRb2 := 256;
  end;
  if chkGreenToRedMin.Checked = True then
  begin
    GRa1 := StrToFloat(edGRa1.Text);
    GRb1 := StrToFloat(edGRb1.Text);
  end
  else
  begin
    GRa1 := 0;
    GRb1 := 0;
  end;
  if chkGreenToRedMax.Checked = True then
  begin
    GRa2 := StrToFloat(edGRa2.Text);
    GRb2 := StrToFloat(edGRb2.Text);
  end
  else
  begin
    GRa2 := 1000;
    GRb2 := 256;
  end;
  ChangeColor := chkChangeColor.Checked;
  AlterColor := ColorPanel.Color;
  BasedOnBrightness := chkBrightness.Checked;
  BrightnessLimit := ConditionDialog.TrackBar.Position / 10;
end;

procedure TConditionDialog.ColorPanelDblClick(Sender: TObject);
begin
  if (chkChangeColor.Enabled) and (ColorDialog.Execute) then
  begin
    ColorPanel.Color := ColorDialog.Color;
    chkChangeColor.Checked := True;
  end;
end;

procedure TConditionDialog.btnHelpClick(Sender: TObject);
begin
  {$ifdef Linux}
  //Main.IndexClick(Sender);
  //InvokeHelp;
  {$else}
  //Keybd_Event(VK_F1, 0, 0, 0);
  {$endif}
end;

procedure TConditionDialog.chkBrightnessClick(Sender: TObject);
begin
  if chkBrightness.Checked then
  begin
    seRedMin.Enabled := False;
    seRedMax.Enabled := False;
    chkBlueToRedMin.Enabled := False;
    chkBlueToRedMax.Enabled := False;
    chkGreenToRedMin.Enabled := False;
    chkGreenToRedMax.Enabled := False;
    edBRa1.Enabled := False;
    edBRa2.Enabled := False;
    edGRa2.Enabled := False;
    edGRa1.Enabled := False;
  end
  else
  begin
    seRedMin.Enabled := True;
    seRedMax.Enabled := True;
    chkBlueToRedMin.Enabled := True;
    chkBlueToRedMax.Enabled := True;
    chkGreenToRedMin.Enabled := True;
    chkGreenToRedMax.Enabled := True;
    edBRa1.Enabled := True;
    edBRa2.Enabled := True;
    edGRa2.Enabled := True;
    edGRa1.Enabled := True;
  end
end;

Initialization
{$I Condition_Dialog.lrs}
end.
