unit Help_Search;

interface

{$mode delphi}{$H+}
uses 
  LResources,
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, HelpTreeView;

type

  { THelpSearch }

  THelpSearch = class(TForm)
    btnSearch: TButton;
    edSearch: TEdit;
    HelpTreeView: THelpTreeView;
    TabControl: TTabControl;
    procedure FormShow(Sender: TObject);
    procedure TabControlChange(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure edSearchKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private

  public
  end;

var
  HelpSearch: THelpSearch;

implementation

procedure THelpSearch.FormShow(Sender: TObject);
begin
  btnSearch.Enabled := False;
  TabControlChange(Sender);
end;

procedure THelpSearch.TabControlChange(Sender: TObject);
begin
  btnSearch.Enabled := False;
  case TabControl.TabIndex of
  0:begin
      HelpTreeView.ShowContents;
      {$ifdef Linux}
      HelpKeyword := '7';
      {$else}
      HelpContext := 7;
      {$endif}
      edSearch.Enabled := False;
    end;
  1:begin
      HelpTreeView.ShowIndex;
      {$ifdef Linux}
      HelpKeyword := '4';
      {$else}
      HelpContext := 4;
      {$endif}
      edSearch.Enabled := True;
    end;
  2:begin
      btnSearch.Enabled := True;
      {$ifdef Linux}
      HelpKeyword := '5';
      {$else}
      HelpContext := 5;
      {$endif}
      edSearch.Enabled := True;
      HelpTreeView.Items.Clear;
    end;
  end;
end;

procedure THelpSearch.btnSearchClick(Sender: TObject);
begin
  HelpTreeView.SearchText(edSearch.Text);
end;

procedure THelpSearch.edSearchKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  HelpTreeView.SearchIndex(edSearch.Text);
end;

Initialization
{$I Help_Search.lrs}
end.
